//
//  ARsampleAppDelegate.h
//  ARsample
//
//  Created by hak on 5/14/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>

//-------------------------------------------------------
//Definitions
//-------------------------------------------------------
#define kFilteringFactor 0.05

//-------------------------------------------------------
//Forward decl
//-------------------------------------------------------
@class EAGLView;

//-------------------------------------------------------
//Interface
//-------------------------------------------------------
@interface ARsampleAppDelegate : NSObject <UIApplicationDelegate, UIAccelerometerDelegate, CLLocationManagerDelegate> {
    UIWindow *window;
    EAGLView *glView;
    UIImagePickerController *cameraController;
    UIViewController        *viewController;

	CLLocationManager   *locationManager;           //Location manager
	UIAccelerometer     *accelerometerManager;      //Allelerometer
@private
    float _azimuth;
    float _accerelometerX;
    float _accerelometerY;
    float _accerelometerZ;
    float _magnetometerX;
    float _magnetometerY;
    float _magnetometerZ;
}

@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet EAGLView *glView;
@property (nonatomic, retain) IBOutlet UIViewController *viewController;

@property (nonatomic, retain) CLLocationManager *locationManager;
@property (nonatomic, retain) UIAccelerometer *accelerometerManager;

@property (readonly, assign) float _azimuth;
@property (readonly, assign) float _accerelometerX;
@property (readonly, assign) float _accerelometerY;
@property (readonly, assign) float _accerelometerZ;
@property (readonly, assign) float _magnetometerX;
@property (readonly, assign) float _magnetometerY;
@property (readonly, assign) float _magnetometerZ;
@end

